/*
The software in this package is distributed under the GNU General
Public License version 2 (with a special exception described below).

A copy of GNU General Public License (GPL) is included in this distribution,
in the file COPYING.GPL.

As a special exception, if other files instantiate templates or use macros
or inline functions from this file, or you compile this file and link it
with other works to produce a work based on this file, this file
does not by itself cause the resulting work to be covered
by the GNU General Public License.

However the source code for this file must still be made available
in accordance with section (3) of the GNU General Public License.

This exception does not invalidate any other reasons why a work based
on this file might be covered by the GNU General Public License.
*/
/***************************************************************************
 *   Copyright (C) 2006 by Intra2net AG                                    *
 *                                                                         *
 ***************************************************************************/

#ifndef __LOGREAD_HXX
#define __LOGREAD_HXX

#include <string>

/**
    Log file reader class.

    Works on complete and incomplete lines.
    Devire from this class and implement your
    own processLine() / processUnfinishedLine() function.
*/
class logread
{
public:
    logread(std::string filename, bool _goto_end=false);
    void read();

protected:
    std::string line;

    virtual void processUnfinishedLine() {};
    virtual void processLine() {};

private:
    // Internal implementation
    void reset();
    void goto_end();

    bool check_changed();
    bool process();

    std::string getLogChanges();
    void extractSingeLine (std::string &input);

    std::string filename;
    int logsize;
    int logsize_old;

    bool line_complete;
};

#endif
